/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the MessageButtonUrlOptions type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageButtonUrlOptions{}

// MessageButtonUrlOptions struct for MessageButtonUrlOptions
type MessageButtonUrlOptions struct {
	AutoShortLink *bool `json:"auto_short_link,omitempty"`
	ExpiredUrl *string `json:"expired_url,omitempty"`
	Ttl *int32 `json:"ttl,omitempty"`
	WithTxId *bool `json:"with_tx_id,omitempty"`
	Type *string `json:"type,omitempty"`
}

// NewMessageButtonUrlOptions instantiates a new MessageButtonUrlOptions object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageButtonUrlOptions() *MessageButtonUrlOptions {
	this := MessageButtonUrlOptions{}
	return &this
}

// NewMessageButtonUrlOptionsWithDefaults instantiates a new MessageButtonUrlOptions object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageButtonUrlOptionsWithDefaults() *MessageButtonUrlOptions {
	this := MessageButtonUrlOptions{}
	return &this
}

// GetAutoShortLink returns the AutoShortLink field value if set, zero value otherwise.
func (o *MessageButtonUrlOptions) GetAutoShortLink() bool {
	if o == nil || IsNil(o.AutoShortLink) {
		var ret bool
		return ret
	}
	return *o.AutoShortLink
}

// GetAutoShortLinkOk returns a tuple with the AutoShortLink field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButtonUrlOptions) GetAutoShortLinkOk() (*bool, bool) {
	if o == nil || IsNil(o.AutoShortLink) {
		return nil, false
	}
	return o.AutoShortLink, true
}

// HasAutoShortLink returns a boolean if a field has been set.
func (o *MessageButtonUrlOptions) HasAutoShortLink() bool {
	if o != nil && !IsNil(o.AutoShortLink) {
		return true
	}

	return false
}

// SetAutoShortLink gets a reference to the given bool and assigns it to the AutoShortLink field.
func (o *MessageButtonUrlOptions) SetAutoShortLink(v bool) {
	o.AutoShortLink = &v
}

// GetExpiredUrl returns the ExpiredUrl field value if set, zero value otherwise.
func (o *MessageButtonUrlOptions) GetExpiredUrl() string {
	if o == nil || IsNil(o.ExpiredUrl) {
		var ret string
		return ret
	}
	return *o.ExpiredUrl
}

// GetExpiredUrlOk returns a tuple with the ExpiredUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButtonUrlOptions) GetExpiredUrlOk() (*string, bool) {
	if o == nil || IsNil(o.ExpiredUrl) {
		return nil, false
	}
	return o.ExpiredUrl, true
}

// HasExpiredUrl returns a boolean if a field has been set.
func (o *MessageButtonUrlOptions) HasExpiredUrl() bool {
	if o != nil && !IsNil(o.ExpiredUrl) {
		return true
	}

	return false
}

// SetExpiredUrl gets a reference to the given string and assigns it to the ExpiredUrl field.
func (o *MessageButtonUrlOptions) SetExpiredUrl(v string) {
	o.ExpiredUrl = &v
}

// GetTtl returns the Ttl field value if set, zero value otherwise.
func (o *MessageButtonUrlOptions) GetTtl() int32 {
	if o == nil || IsNil(o.Ttl) {
		var ret int32
		return ret
	}
	return *o.Ttl
}

// GetTtlOk returns a tuple with the Ttl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButtonUrlOptions) GetTtlOk() (*int32, bool) {
	if o == nil || IsNil(o.Ttl) {
		return nil, false
	}
	return o.Ttl, true
}

// HasTtl returns a boolean if a field has been set.
func (o *MessageButtonUrlOptions) HasTtl() bool {
	if o != nil && !IsNil(o.Ttl) {
		return true
	}

	return false
}

// SetTtl gets a reference to the given int32 and assigns it to the Ttl field.
func (o *MessageButtonUrlOptions) SetTtl(v int32) {
	o.Ttl = &v
}

// GetWithTxId returns the WithTxId field value if set, zero value otherwise.
func (o *MessageButtonUrlOptions) GetWithTxId() bool {
	if o == nil || IsNil(o.WithTxId) {
		var ret bool
		return ret
	}
	return *o.WithTxId
}

// GetWithTxIdOk returns a tuple with the WithTxId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButtonUrlOptions) GetWithTxIdOk() (*bool, bool) {
	if o == nil || IsNil(o.WithTxId) {
		return nil, false
	}
	return o.WithTxId, true
}

// HasWithTxId returns a boolean if a field has been set.
func (o *MessageButtonUrlOptions) HasWithTxId() bool {
	if o != nil && !IsNil(o.WithTxId) {
		return true
	}

	return false
}

// SetWithTxId gets a reference to the given bool and assigns it to the WithTxId field.
func (o *MessageButtonUrlOptions) SetWithTxId(v bool) {
	o.WithTxId = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *MessageButtonUrlOptions) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButtonUrlOptions) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *MessageButtonUrlOptions) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *MessageButtonUrlOptions) SetType(v string) {
	o.Type = &v
}

func (o MessageButtonUrlOptions) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageButtonUrlOptions) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.AutoShortLink) {
		toSerialize["auto_short_link"] = o.AutoShortLink
	}
	if !IsNil(o.ExpiredUrl) {
		toSerialize["expired_url"] = o.ExpiredUrl
	}
	if !IsNil(o.Ttl) {
		toSerialize["ttl"] = o.Ttl
	}
	if !IsNil(o.WithTxId) {
		toSerialize["with_tx_id"] = o.WithTxId
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableMessageButtonUrlOptions struct {
	value *MessageButtonUrlOptions
	isSet bool
}

func (v NullableMessageButtonUrlOptions) Get() *MessageButtonUrlOptions {
	return v.value
}

func (v *NullableMessageButtonUrlOptions) Set(val *MessageButtonUrlOptions) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageButtonUrlOptions) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageButtonUrlOptions) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageButtonUrlOptions(val *MessageButtonUrlOptions) *NullableMessageButtonUrlOptions {
	return &NullableMessageButtonUrlOptions{value: val, isSet: true}
}

func (v NullableMessageButtonUrlOptions) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageButtonUrlOptions) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


